問題:
LeetCode-3
English:
Given a string, find the length of the longest substring without repeating characters.
Example 1:
Input: "abcabcbb"
Output: 3
Explanation: The answer is "abc", with the length of 3.
Example 2:
Input: "bbbbb"
Output: 1
Explanation: The answer is "b", with the length of 1.
Example 3:
Input: "pwwkew"
Output: 3
Explanation: The answer is "wke", with the length of 3.
Note that the answer must be a substring, "pwke" is a subsequence and not a substring
中文:
給定一個字符串捏题,請你找出其中不含有重復(fù)字符的 最長子串 的長度玻褪。
示例 1:
輸入: "abcabcbb"
輸出: 3
解釋: 因為無重復(fù)字符的最長子串是 "abc"公荧,所以其長度為 3。
示例 2:
輸入: "bbbbb"
輸出: 1
解釋: 因為無重復(fù)字符的最長子串是 "b"循狰,所以其長度為 1。
示例 3:
輸入: "pwwkew"
輸出: 3
解釋: 因為無重復(fù)字符的最長子串是 "wke"绪钥,所以其長度為 3。
請注意程腹,你的答案必須是 子串 的長度,"pwke" 是一個子序列寸潦,不是子串
解法:
通過使用HashMap來記錄字符串中的字母和字母的位置,并使用頭尾來控制字符串長度见转,每次碰到新字母長度就加一,如果頭部碰到舊字母斩箫,則將尾進一,頭進一乘客,并統(tǒng)計新子序列的長度,并找出最大的子序列
代碼實現(xiàn)(java版)
if (s == null || s.length() == 0)
return 0;
HashMap<Character, Integer> map = new HashMap<Character, Integer>();
int length = 0;
int tail =0;
for (int i = 0; i < s.length(); i++) {
if (map.containsKey(s.charAt(i))) {
/*
* 發(fā)生重復(fù)氛雪,則將tail進行前移 如果下一位是新的字母,則將其位置賦值給tail
* 如果是老字母报亩,說明此長度已經(jīng)計數(shù),則tail保持
*/
tail = Math.max(tail, map.get(s.charAt(i)) + 1);
}
/*
* 字母進哈希表, 如果是新字母弦追,則開辟新空間存儲起來
* 如果是老字母,則將新位置賦值給老字母花竞,以便計算新長度
*/
map.put(s.charAt(i), i);
/*
* 記錄下每次比較的長度,并從中找出最大值
*/
length = Math.max(length, i - tail + 1);
}
return length;